#ifndef OgreMax_CommonSettings_INCLUDED
#define OgreMax_CommonSettings_INCLUDED


//Classes----------------------------------------------------------------------
namespace OgreMax 
{
    struct ItemAllow
    {
        TSTR name;
        TSTR allow;
    };

    struct BoneAllow : ItemAllow
    {
        TSTR tree; //true or false
    };

    struct ItemXYZ
    {
        TSTR name;
        TSTR xyz;
    };

    struct UserDataSettings
    {
        TSTR id;
        TSTR userDataMarker;
        TSTR userDataReference;
        TSTR userData;
        TSTR isUserDataCDATA;

        void ClearDefaults();
    };
    
    struct LodSettings
    {
        TSTR generateLod;                       //Indicates whether LoD meshes should be generated        
        TSTR numLodLevels;              //Number of LoD meshes to generate
        TSTR lodDistance;                      //Distance increment per LoD level        
        TSTR lodReductionType;      //Indicates the type of lod reduction performed
        TSTR lodReductionAmount;              //LoD reduction amount        

        void ClearDefaults();
    };

    struct HardwareBufferUsage
    {
        TSTR usage;
        TSTR useShadow;

        void ClearDefaults();
    };

    struct Rename
    {
        TSTR from;
        TSTR to;
    };

    struct NumberedValue
    {
        NumberedValue()
        {
            this->number = 0;
        }
        int number;
        TSTR value;
    };

    struct RemoveBoneTranslation
    {
        TSTR boneName;
        TSTR xyz;
    };

    struct CommonSettings
    {
        struct Values
        {
            static bool IsUserDataCDATA(const TSTR& value);

            static bool IsGenerateLodEnabled(const TSTR& text);

            static const TCHAR* LOD_REDUCTION_TYPES[];
            static const int LOD_REDUCTION_TYPE_COUNT;
        };

        static void Write(TSTR& result, const TSTR& key, const std::vector<ItemAllow>& items, const TSTR& newline);
        static void WriteNames(TSTR& result, const std::vector<ItemAllow>& items, const TSTR& newline);
        static void WriteNames(TSTR& result, const std::vector<ItemAllow>& items, bool allowValue, const TSTR& newline);

        static void Write(TSTR& result, const std::vector<Rename>& items, const TSTR& newline);
        
        static void WriteValues(TSTR& result, const std::vector<NumberedValue>& items, const TSTR& newline);

        static void Write(TSTR& result, const std::vector<RemoveBoneTranslation>& items, const TSTR& newline);
    };
}


#endif