
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "ControlUtilities.h"

using namespace OgreMax;


//Implementation----------------------------------------------------------------
void ControlUtilities::FillComboBox(HWND hWnd, const TCHAR* items[], int itemCount)
{
    for (int i = 0; i < itemCount; i++)
        SendMessage(hWnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(items[i]));

    SendMessage(hWnd, CB_SETCURSEL, 0, 0);
}

void ControlUtilities::FillBlendFactorComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("One"),
        _T("Zero"),
        _T("Dest Color"),
        _T("Source Color"),
        _T("Inv Dest Color"),
        _T("Inv Src Color"),
        _T("Dest Alpha"),
        _T("Source Alpha"),
        _T("Inv Dest Alpha"),
        _T("Inv Src Alpha")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillShadingComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Flat"),
        _T("Gouraud"),
        _T("Phong")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillDepthFunctionComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Always Fail"),
        _T("Always Pass"),
        _T("Less"),
        _T("Less Equal"),
        _T("Equal"),
        _T("Not Equal"),
        _T("Greater Equal"),
        _T("Greater")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillAlphaFunctionComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Always Fail"),
        _T("Always Pass"),
        _T("Less"),
        _T("Less Equal"),
        _T("Equal"),
        _T("Not Equal"),
        _T("Greater Equal"),
        _T("Greater")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillHardwareCullComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("None"),
        _T("Clockwise"),
        _T("Counter-clockwise")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillSoftwareCullComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("None"),
        _T("Back"),
        _T("Front")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);        
}

void ControlUtilities::FillFogFunctionComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("None"),
        _T("Exp"),
        _T("Exp2"),
        _T("Linear")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);
}

void ControlUtilities::FillLightTypeComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Point"),
        _T("Directional"),
        _T("Spot"),
        _T("All")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);
}

void ControlUtilities::FillBitmapDimensionComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("1D"),
        _T("2D"),
        _T("3D"),
        _T("Cubic")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillColorAlphaBlendFunctionComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Source1"),
        _T("Source2"),
        _T("Modulate"),
        _T("ModulateX2"),
        _T("ModulateX4"),
        _T("Add Signed"),
        _T("Add Smooth"),
        _T("Subtract"),
        _T("Diffuse Alpha"),
        _T("Texture Alpha"),
        _T("Current Alpha"),
        _T("Manual"),
        _T("Dot Product")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillColorAlphaBlendSourceComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Current"),
        _T("Texture"),
        _T("Diffuse"),
        _T("Specular"),
        _T("Manual")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillColorAlphaBlendDestinationComboBox(HWND hWnd)
{
    FillColorAlphaBlendSourceComboBox(hWnd);
}

void ControlUtilities::FillEnvironmentMappingComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Off"),
        _T("Planar"),
        _T("Spherical"),
        _T("Reflection"),
        _T("Normal")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillAddressingModeComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Wrap"),
        _T("Mirror"),
        _T("Clamp")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillFilteringModeComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("None"),
        _T("Bilinear"),
        _T("Trilinear"),
        _T("Anisotropic")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillTextureTransformAnimationTransformTypeComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Scroll U"),
        _T("Scroll V"),
        _T("Scale U"),
        _T("Scale V"),
        _T("Rotate")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillTextureTransformAnimationWaveTypeComboBox(HWND hWnd)
{
    static const TCHAR* items[] =
    {
        _T("Sine"),
        _T("Triangle"),
        _T("Square"),
        _T("Sawtooth"),
        _T("Inverse")
    };
    static const int itemCount = sizeof(items)/sizeof(items[0]);

    FillComboBox(hWnd, items, itemCount);    
}

void ControlUtilities::FillListBox(HWND hWnd, const TSTR* items, int itemCount)
{
    //Clear the list box
    SendMessage(hWnd, LB_RESETCONTENT, 0, 0);        

    //Fill the list box
    for (int i = 0; i < itemCount; i++)
    {
        SendMessage
            (
            hWnd, 
            LB_ADDSTRING, 
            0, 
            reinterpret_cast<LPARAM>(items[i].data())
            ); 
    }
}

BOOL ControlUtilities::IsListViewSelectedItemChange(NMLISTVIEW* listViewNotify)
{
    if (listViewNotify->hdr.code == LVN_ITEMCHANGED)
    {  
        //Has the item's state changed?
        if ((listViewNotify->uChanged & LVIF_STATE) != LVIF_STATE)
        {
            //No, it hasn't
            return FALSE;
        }

        //Has the selected state changed?
        if (!(listViewNotify->uNewState & LVIS_SELECTED) || (listViewNotify->uOldState & LVIS_SELECTED))
        {
            //No, it hasn't
            return FALSE; 
        }

        return TRUE;
    }

    return FALSE;
}

void ControlUtilities::SetListViewItem(HWND hWnd, const TCHAR* text, int itemIndex, int subitemIndex)
{
    LVITEM item;
    item.mask = LVIF_TEXT;
    item.iItem = itemIndex;
    item.iSubItem = subitemIndex;
    item.pszText = const_cast<TCHAR*>(text);
    ListView_SetItem(hWnd, &item);
}

void ControlUtilities::InsertListViewItem(HWND hWnd, const TCHAR* text, int itemIndex, int subitemIndex)
{
    LVITEM item;
    item.mask = LVIF_TEXT;
    item.iItem = itemIndex;
    item.iSubItem = subitemIndex;
    item.pszText = const_cast<TCHAR*>(text);
    if (subitemIndex == 0)
        ListView_InsertItem(hWnd, &item);
    else
        ListView_SetItem(hWnd, &item);    
}

void ControlUtilities::InsertListViewColumn(HWND hWnd, const TCHAR* text, int columnIndex, int columnWidth)
{
    LV_COLUMN column;
    column.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
    column.fmt = LVCFMT_LEFT;
    column.pszText = const_cast<TCHAR*>(text);
    column.cx = columnWidth;
    ListView_InsertColumn(hWnd, columnIndex, &column);
}

int ControlUtilities::GetListViewSelectedItem(HWND hWnd)
{
    return ListView_GetNextItem(hWnd, -1, LVNI_FOCUSED);
}

TSTR ControlUtilities::GetText(HWND hWnd)
{
    LRESULT length = SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
    TSTR text;
    text.Resize(length + 1);

    SendMessage(hWnd, WM_GETTEXT, length + 1, reinterpret_cast<LPARAM>(text.data()));

    return text;
}

void ControlUtilities::SetText(HWND hWnd, const TCHAR* text)
{    
    SendMessage(hWnd, WM_SETTEXT, 0, reinterpret_cast<LPARAM>(text));
}
