#ifndef OgreMax_ControlUtilities_INCLUDED
#define OgreMax_ControlUtilities_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    /**
     * A collection of utility functions for filling in user interface controls.
     */
    class ControlUtilities
    {
    private:
        /**
         * Disable instantiation.
         */
	    ControlUtilities();

    public:    
        static void FillComboBox(HWND hWnd, const TCHAR* items[], int itemCount);
        static void FillBlendFactorComboBox(HWND hWnd);
        static void FillShadingComboBox(HWND hWnd);
        static void FillDepthFunctionComboBox(HWND hWnd);
        static void FillAlphaFunctionComboBox(HWND hWnd);
        static void FillHardwareCullComboBox(HWND hWnd);
        static void FillSoftwareCullComboBox(HWND hWnd);
        static void FillFogFunctionComboBox(HWND hWnd);
        static void FillLightTypeComboBox(HWND hWnd);
        static void FillBitmapDimensionComboBox(HWND hWnd);
        static void FillColorAlphaBlendFunctionComboBox(HWND hWnd);
        static void FillColorAlphaBlendSourceComboBox(HWND hWnd);
        static void FillColorAlphaBlendDestinationComboBox(HWND hWnd);
        static void FillEnvironmentMappingComboBox(HWND hWnd);
        static void FillAddressingModeComboBox(HWND hWnd);
        static void FillFilteringModeComboBox(HWND hWnd);
        static void FillTextureTransformAnimationTransformTypeComboBox(HWND hWnd);
        static void FillTextureTransformAnimationWaveTypeComboBox(HWND hWnd);

        static void FillListBox(HWND hWnd, const TSTR* items, int itemCount);

        static BOOL IsListViewSelectedItemChange(NMLISTVIEW* listViewNotify);
        static void SetListViewItem(HWND hWnd, const TCHAR* text, int itemIndex, int subitemIndex = 0);
        static void InsertListViewItem(HWND hWnd, const TCHAR* text, int itemIndex, int subitemIndex = 0);
        static void InsertListViewColumn(HWND hWnd, const TCHAR* text, int columnIndex, int columnWidth = 50);
        static int GetListViewSelectedItem(HWND hWnd);

        static TSTR GetText(HWND hWnd);
        static void SetText(HWND hWnd, const TCHAR* text);        
    };
}


#endif

