#if !defined(__OGRE_MAX_EXPORT_H__)
#define __OGRE_MAX_EXPORT_H__


//Includes---------------------------------------------------------------------
#include "ExportSettings.h"


//Classes----------------------------------------------------------------------
namespace OgreMax 
{
    typedef std::map<TSTR, TSTR> StringStringMap;

	class ExporterBase 
    {
	public:
		ExporterBase
            (
            const ExportSettings& settings, 
            IGameScene* gameInterface,
            Interface* maxInterface
            ) :
          exportSettings(settings) 
        {
            this->gameInterface = gameInterface;
            this->exportInterface = exportInterface; 
            this->maxInterface = maxInterface; 
        }

	protected:
		const ExportSettings& exportSettings;

        IGameScene* gameInterface;
		ExpInterface* exportInterface;
		Interface* maxInterface;
	};

}

#endif