/********************************************************************
*
* Copyright (C) 1999-2000 Sven Wiegand
* Copyright (C) 2000-2001 ToolsCenter
* 
* This file is free software; you can redistribute it and/or
* modify, but leave the headers intact and do not remove any 
* copyrights from the source.
*
* If you have further questions, suggestions or bug fixes, visit 
* our homepage
*
*    http://www.ToolsCenter.org
*
********************************************************************/

#if !defined(AFX_FILEVERSION_H__F828004C_7680_40FE_A08D_7BB4FF05B4CC__INCLUDED_)
#define AFX_FILEVERSION_H__F828004C_7680_40FE_A08D_7BB4FF05B4CC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class FileVersionInfo
{
// construction/destruction
public:
	FileVersionInfo();
	virtual ~FileVersionInfo();

// operations
public:
	BOOL Create(HMODULE hModule = NULL);
	BOOL Create(LPCTSTR lpszFileName);

// attribute operations
public:
	WORD GetFileVersion(int nIndex) const;
	WORD GetProductVersion(int nIndex) const;
	DWORD GetFileFlagsMask() const;
	DWORD GetFileFlags() const;
	DWORD GetFileOs() const;
	DWORD GetFileType() const;
	DWORD GetFileSubtype() const;
	FILETIME GetFileDate() const;

	const TSTR& GetCompanyName() const;
	const TSTR& GetFileDescription() const;
	const TSTR& GetFileVersion() const;
	const TSTR& GetInternalName() const;
	const TSTR& GetLegalCopyright() const;
	const TSTR& GetOriginalFileName() const;
	const TSTR& GetProductName() const;
	const TSTR& GetProductVersion() const;
	const TSTR& GetComments() const;
	const TSTR& GetLegalTrademarks() const;
	const TSTR& GetPrivateBuild() const;
	const TSTR& GetSpecialBuild() const;

// implementation helpers
protected:
	virtual void Reset();
	BOOL GetTranslationId(LPVOID lpData, UINT unBlockSize, WORD wLangId, DWORD &dwId, BOOL bPrimaryEnough = FALSE);

// attributes
private:
	VS_FIXEDFILEINFO m_FileInfo;

	TSTR m_strCompanyName;
	TSTR m_strFileDescription;
	TSTR m_strFileVersion;
	TSTR m_strInternalName;
	TSTR m_strLegalCopyright;
	TSTR m_strOriginalFileName;
	TSTR m_strProductName;
	TSTR m_strProductVersion;
	TSTR m_strComments;
	TSTR m_strLegalTrademarks;
	TSTR m_strPrivateBuild;
	TSTR m_strSpecialBuild;
};

#endif // !defined(AFX_FILEVERSION_H__F828004C_7680_40FE_A08D_7BB4FF05B4CC__INCLUDED_)
