
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "IncludeExcludeBoneAnimationDialog.h"
#include "Utilities.h"
#include "PluginGlobals.h"
#include "resource.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
IncludeExcludeBoneAnimationDialog::IncludeExcludeBoneAnimationDialog()
{
    this->include = false;
    this->isTree = true;
}

int IncludeExcludeBoneAnimationDialog::DoModal(HWND hWndParent)
{
    return DialogBase::DoModal(IDD_INCLUDE_EXCLUDE_BONE_ANIMATION_DIALOG, hWndParent);
}

INT_PTR IncludeExcludeBoneAnimationDialog::DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled)
{
    switch (message)
    {
        case WM_INITDIALOG:
        {
            //Center in parent window
            CenterWindow();

            CheckRadioButton(IDC_INCLUDE_RADIO, IDC_EXCLUDE_RADIO, this->include ? IDC_INCLUDE_RADIO : IDC_EXCLUDE_RADIO);
            CheckDlgButton(IDC_BONE_TREE_CHECK, this->isTree);

            handled = true;

            break;
        }
        case WM_COMMAND:
        {
            int id = LOWORD(wParam);
            int code = HIWORD(wParam);

            switch (id)
            {
                case IDOK:
                {
                    GetDlgItemText(IDC_BONE_NAME_EDIT, this->boneName);
                    this->include = IsDlgButtonChecked(IDC_INCLUDE_RADIO) ? true : false;
                    this->isTree = IsDlgButtonChecked(IDC_BONE_TREE_CHECK) ? true : false;

                    handled = true;

                    if (this->boneName.isNull())
                    {
                        Utilities::ShowMessage(PluginGlobals::GetString(IDS_BONE_NAME_REQUIRED), PluginGlobals::GetString2(IDS_DATA_ENTRY_ERROR), MB_ICONINFORMATION | MB_OK);
                        SetFocus(GetDlgItem(IDC_BONE_NAME_EDIT));
                    }
                    else                    
                        EndDialog(this->hDlg, TRUE);

                    return TRUE;
                }
                case IDCANCEL:
                {
                    handled = true;
                    EndDialog(this->hDlg, FALSE);
                    return FALSE;
                }
            }

            break;
        }
    }

    return 0;
}