
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "ListControl.h"
#include "PluginGlobals.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
ListControl::ListControl()
{
}

ListControl::~ListControl()
{
}

void ListControl::Create(HWND hList)
{
    this->hList = hList;

    DWORD style = LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT; 
    ListView_SetExtendedListViewStyleEx(this->hList, style, style);
}

void ListControl::InsertColumn(int columnStringID, int column, int width)
{
    LVCOLUMN columnData;
    columnData.mask = LVCF_WIDTH | LVCF_TEXT;
    columnData.cx = width;
    columnData.pszText = PluginGlobals::GetString(columnStringID);
    ListView_InsertColumn(this->hList, column, &columnData);
}

void ListControl::InsertItem(int row, int column, const TSTR& text, LPARAM data)
{
    LVITEM itemData;
    itemData.mask = LVIF_TEXT;
    itemData.pszText = (TCHAR*)text.data();
    itemData.iItem = row;
    itemData.iSubItem = column;
    if (column == 0)
    {
        itemData.mask |= LVIF_PARAM;
        itemData.lParam = data;
        ListView_InsertItem(this->hList, &itemData);
    }
    else
        ListView_SetItem(this->hList, &itemData);
}

void ListControl::SetItem(int row, int column, const TSTR& text)
{
    LVITEM itemData;
    itemData.mask = LVIF_TEXT;
    itemData.pszText = (TCHAR*)text.data();
    itemData.iItem = row;
    itemData.iSubItem = column;
    ListView_SetItem(this->hList, &itemData);
}

int ListControl::GetCurSel()
{
    return ListView_GetSelectionMark(this->hList);
}

LPARAM ListControl::GetData(int row)
{
    LVITEM itemData;
    itemData.mask = LVIF_PARAM;
    itemData.iItem = row;
    itemData.iSubItem = 0;
    ListView_GetItem(this->hList, &itemData);
    return itemData.lParam;
}