
#ifndef OgreMax_MaterialExporter_INCLUDED
#define OgreMax_MaterialExporter_INCLUDED


//Includes---------------------------------------------------------------------
#include "ExportSettings.h"
#include "ExporterBase.h"

class ExportMat;
//Classes----------------------------------------------------------------------
namespace OgreMax 
{
    typedef std::map<TSTR, IGameMaterial*> MaterialMap;

	class MaterialExporter : public ExporterBase
	{
	public:
        MaterialExporter
            (
            const KeyedValues& sceneProperties,
            const ExportSettings& settings, 
            IGameScene* gameInterface,
            Interface* maxInterface
            );
		virtual ~MaterialExporter();

        void ExportMaterials(const MaterialMap& materials);		

	protected:		
        bool ExportMaterials(const MaterialMap& materialMap, TSTR& output);
		bool ExportMaterial(IGameMaterial* material, const TSTR& materialName, TSTR& output);

		bool WritePass(stdostream& out, const TSTR& materialName, IGameMaterial* material);
		bool WriteMaterials(const MaterialMap& materialMap, stdostream& out); 
		void AddMultitexture(ExportMat&emat, Texmap * mtmap, int suboffset, bool lastmult);
    private:
        const KeyedValues& sceneProperties;
	};
}

#endif
