
#ifndef OgreMax_MeshAnimationSettingsSerializer_INCLUDED
#define OgreMax_MeshAnimationSettingsSerializer_INCLUDED


//Includes---------------------------------------------------------------------
#include "SettingsSerializer.h"
#include "MeshAnimationSettings.h"


//Classes----------------------------------------------------------------------
namespace OgreMax 
{
    /** Serializer for one mesh animation */
    class MeshAnimationSettingsSerializer : public SettingsSerializer
    {
    public:
        MeshAnimationSettingsSerializer();

    private:
        void ParseProperty
            (
            const TSTR& key, 
            const TSTR& value, 
            int line, 
            std::vector<int>& handledLines
            );

        void GetPropertiesText(TSTR& text, const TSTR& newline);

    public:
        /** The track that the animation is located on */
        enum Track
        {
            NONE,
            OBJECT,
            MORPHER,
            PHYSIQUE,
            SKIN
        };
        Track track;

        Interval timeInterval;

        /** The note key from which the settings were read */
        NoteKey* noteKey;

        MeshAnimationSettings settings;    

        bool changed;
    };

    class AllMeshAnimationSettingsSerializer
    {
    public:
        AllMeshAnimationSettingsSerializer();

        void Read(INode* node);

        void Write();

    protected:
        INode* node;

        enum {MODIFIER_TRACK_COUNT = 4};
        DefNoteTrack* noteTracks[MODIFIER_TRACK_COUNT];

    public:
        std::vector<MeshAnimationSettingsSerializer> settings;
    };
}


#endif