
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "ModelExporter.h"

using namespace OgreMax;

//Implementation----------------------------------------------------------------
ModelExporter::ModelExporter
    (
    const TSTR& modelName,
    IGameNode* gameNode, 
    PhysicsExportType physicsExportType
    ) : physicsExporter(physicsExportType)
{
    this->gameNode = gameNode;
    this->modelName = modelName;

    this->rootXmlElement = (TiXmlElement*)this->xmlDocument.LinkEndChild(new TiXmlElement(_T("node")));    

    this->rootXmlBindingsElement = (TiXmlElement*)this->xmlBindingsDocument.LinkEndChild(new TiXmlElement(_T("bindings")));    
}

TiXmlElement* ModelExporter::GetRootNodeXmlElement()
{
    return this->rootXmlElement;
}

TiXmlElement* ModelExporter::GetRootPhysicsXmlElement()
{
    return this->physicsExporter.GetRootNodeXmlElement();
}

TiXmlElement* ModelExporter::GetRootBindingsXmlElement()
{
    return this->rootXmlBindingsElement;
}

const TSTR& ModelExporter::GetModelName() const
{
    return this->modelName;
}

void ModelExporter::Save(const TSTR& fileName)
{
    this->xmlDocument.SaveFile(fileName.data());
    
    if (this->physicsExporter.Save(fileName))
    {    
        TSTR bindingsFileName = fileName + _T(".bindings");
        this->xmlBindingsDocument.SaveFile(bindingsFileName);
    }
}