#ifndef OgreMax_OgreMaxModelExporter_INCLUDED
#define OgreMax_OgreMaxModelExporter_INCLUDED


//Includes---------------------------------------------------------------------
#include "PhysicsExporter.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class ModelExporter
    {
    public:
        ModelExporter(const TSTR& modelName, IGameNode* gameNode, PhysicsExportType physicsExportType);

        TiXmlElement* GetRootNodeXmlElement();

        TiXmlElement* GetRootPhysicsXmlElement();

        TiXmlElement* GetRootBindingsXmlElement();

        const TSTR& GetModelName() const;
        
        void Save(const TSTR& fileName);

    private:
        IGameNode* gameNode;
        TSTR modelName;

        TiXmlDocument xmlDocument;
        TiXmlElement* rootXmlElement;

        TiXmlDocument xmlBindingsDocument;
        TiXmlElement* rootXmlBindingsElement;

        PhysicsExporter physicsExporter;
    };
}


#endif