
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "ObjectSettings.h"
#include "Utilities.h"
#include "PropertyValues.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
void ObjectSettings::ClearDefaults()
{
    UserDataSettings::ClearDefaults();

    LodSettings::ClearDefaults();
    if (this->lodReductionType.isNull())
        this->lodReductionAmount = _T("");

    if (Utilities::IsSameNoCase(this->isModel, PropertyValues::FALSE_TEXT))
        this->isModel = _T("");
    if (Utilities::IsSameNoCase(this->animationEnabled, PropertyValues::TRUE_TEXT))
        this->animationEnabled = _T("");
    if (Utilities::IsSameNoCase(this->animationLooped, PropertyValues::TRUE_TEXT))
        this->animationLooped = _T("");
    if (Utilities::IsSameNoCase(this->animationLooped, PropertyValues::TRUE_TEXT))
        this->animationLooped = _T("");
    if (Utilities::IsSameNoCase(this->renderQueue, PropertyValues::RenderQueue::MAIN))
        this->renderQueue = _T("");
    if (Utilities::IsSameNoCase(this->isStatic, PropertyValues::FALSE_TEXT))
        this->isStatic = _T("");
    this->vertexBufferUsage.ClearDefaults();
    this->indexBufferUsage.ClearDefaults();
    if (Utilities::IsSameNoCase(this->isSimple, PropertyValues::FALSE_TEXT))
        this->isSimple = _T("");
    if (Utilities::IsSameNoCase(this->enableSky, PropertyValues::TRUE_TEXT))
        this->enableSky = _T("");
    if (Utilities::IsSameNoCase(this->drawSkyFirst, PropertyValues::TRUE_TEXT))
        this->drawSkyFirst = _T("");
    if (Utilities::IsSameNoCase(this->billboardType, PropertyValues::BillboardSetType::POINT))
        this->billboardType = _T("");
    if (Utilities::IsSameNoCase(this->billboardOrigin, PropertyValues::BillboardOrigin::CENTER))
        this->billboardOrigin = _T("");
    if (Utilities::IsSameNoCase(this->billboardRotationType, PropertyValues::BillboardRotationType::VERTEX))
        this->billboardRotationType = _T("");
    if (Utilities::IsSameNoCase(this->generateNormals, PropertyValues::TRUE_TEXT))
        this->generateNormals = _T("");
    if (Utilities::IsSameNoCase(this->ignoreChildren, PropertyValues::FALSE_TEXT))
        this->ignoreChildren = _T("");    
}

TSTR ObjectSettings::Values::GetRenderQueue(const TSTR& renderQueueText)
{
    TSTR renderQueue = renderQueueText;

    int addIndex = renderQueueText.first(_T('+'));
    if (addIndex != -1)
    {
        renderQueue = renderQueueText.Substr(0, addIndex);
        Utilities::TrimWhitespace(renderQueue);
    }

    return renderQueue;
}

TSTR ObjectSettings::Values::GetRenderQueueAdd(const TSTR& renderQueueText)
{
    TSTR add;

    int addIndex = renderQueueText.first(_T('+'));
    if (addIndex != -1)
    {
        add = renderQueueText.Substr(addIndex + 1, renderQueueText.length() - addIndex - 1);
        Utilities::TrimWhitespace(add);        
    }

    return add;
}

bool ObjectSettings::Values::IgnoreChildren(const TSTR& text)
{
    return Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsModel(const TSTR& text)
{
    return Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsNodeMainAnimationEnabled(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsNodeMainAnimationLooped(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsStatic(const TSTR& text)
{
    return Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsSimple(const TSTR& text)
{
    return Utilities::ToBool(text);
}

bool ObjectSettings::Values::BufferUsageUseShadow(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::GenerateNormals(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::IsEnabled(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::DrawFirst(const TSTR& text)
{
    return 
        Utilities::IsNull(text) || 
        Utilities::ToBool(text);
}

bool ObjectSettings::Values::CopyFirstKeyToLast(const TSTR& text)
{
    return Utilities::ToBool(text);
}