
#ifndef OgreMax_ObjectSettingsDialog_INCLUDED
#define OgreMax_ObjectSettingsDialog_INCLUDED


//Includes---------------------------------------------------------------------
#include "DialogBase.h"
#include "TabControl.h"
#include "ObjectSettings.h"
#include "ObjectSettingsTabPages.h"
#include "UserDataTabPage.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{    
    class ObjectSettingsDialog : public DialogBase
    {
    public:
        ObjectSettingsDialog(ObjectSettings& settings, INode* node);
        ~ObjectSettingsDialog();

        int DoModal();

        void SelectedObjectType(ObjectTypeDetector::Type objectType);

    protected:
        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

        TabControl tabControl;
        std::vector<DialogBase*> tabPages;

        ObjectSettingsGeneralTabPage generalTabPage;
        UserDataTabPage userDataTabPage;
        ObjectSettingsBillboardTabPage billboardTabPage;
        ObjectSettingsBillboardSetTabPage billboardSetTabPage;
        ObjectSettingsEntityTabPage entityTabPage;
        ObjectSettingsExternalTabPage externalTabPage;
        ObjectSettingsModelInstanceTabPage modelTabPage;
        ObjectSettingsParticleSystemTabPage particleSystemTabPage;
        ObjectSettingsPlaneTabPage planeTabPage;
        ObjectSettingsSkyBoxTabPage boxTabPage;
        ObjectSettingsSkyDomeTabPage skyDomeTabPage;
        ObjectSettingsSkyPlaneTabPage skyPlaneTabPage;
        ObjectSettingsTerrainTabPage terrainTabPage;
        
        ObjectSettings& settings;
        INode* node;
        ObjectTypeDetector objectType;
    };
}

#endif

