#ifndef OgreMax_OgreMaxPasses_INCLUDED
#define OgreMax_OgreMaxPasses_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class PassSlot 
    {
    public:
	    PassSlot();

        BOOL IsOn();
        void SetOn(BOOL on);
        
        void Update(TimeValue t, Interval& ivalid);				
	    
        BOOL HasMap();

        Texmap* GetMap();

    public:
        /** Reference to technique map. */
	    Texmap* map;
	    
        BOOL on;
	    
        TSTR name;
    };

    /**
     * The OgreMaxPasses class is used by the 
     * OgreMaxTechnique class to manage its passes, which are
     * implemented internally as Texmap objects.
     */
    class OgreMaxPasses : public TexmapContainer 
    {
	public:  
        OgreMaxPasses();
		OgreMaxPasses(MtlBase* mtlBase);
		
        void SetName(long i, TSTR& name);
		TSTR& GetName(long i);
		
		void SetClientPtr(MtlBase* mtlBase);
		PassSlot& operator[](int i);
        PassSlot* GetPass(int i);

        /** Gets the ClassDesc for the OgreMaxPasses class. */
        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
		Class_ID ClassID();
		void DeleteThis();
		
        RefTargetHandle Clone(RemapDir& remap = DefaultRemapDir());	
		RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
		    PartID& partID, 
            RefMessage message
            );

		void RescaleWorldUnits(float f);

		BOOL AssignController(Animatable* control, int subAnim);
        
		int NumSubs();
	    Animatable* SubAnim(int i);
		TSTR SubAnimName(int i);
		int SubNumToRefNum(int subNum);
        		
		int NumRefs();
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);

		SvGraphNodeReference SvTraverseAnimGraph
            (
            IGraphObjectManager* gom, 
            Animatable* owner, 
            int id, 
            DWORD flags
            );

		IOResult Save(ISave *isave);
		IOResult Load(ILoad *iload);

    public:
        MtlBase* client;
        
        enum {MAX_PASSES = 4};
		PassSlot passes[MAX_PASSES];
	};
}


#endif