#ifndef OgreMax_OgreMaxRenderTexture_INCLUDED
#define OgreMax_OgreMaxRenderTexture_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class OgreMaxRenderTextureDlg;

    class OgreMaxRenderTexture : public Texmap
    {
    public:
        enum 
        {
            ROLLUP_OPEN                 = 1<<28
        };

        OgreMaxRenderTexture(BOOL loading = FALSE);

        AColor EvalColor(ShadeContext& sc);
        Point3 EvalNormalPerturb(ShadeContext& sc);

        RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
	        PartID& partID, 
            RefMessage message
            );

        void Update(TimeValue t, Interval& valid);

        RefTargetHandle Clone(RemapDir& remap);
        void Reset();

        Interval Validity(TimeValue t);

        ParamDlg* CreateParamDlg(HWND hWndMaterialEdit, IMtlParams* materialParams);

        void SetParamDlg(OgreMaxRenderTextureDlg* paramDlg);

        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
        Class_ID ClassID();
	    SClass_ID SuperClassID();
	    void GetClassName(TSTR& s);
        void DeleteThis();

        TSTR SubAnimName(int i);
        int NumSubs();
        Animatable* SubAnim(int i);
        int NumRefs();
        RefTargetHandle GetReference(int i);
        void SetReference(int i, RefTargetHandle rtarg);
        
        ULONG GetFlags();
        void SetFlag(ULONG f, ULONG value);

        IOResult Save(ISave* isave);
        IOResult Load(ILoad* iload);

    public:
        OgreMaxRenderTextureDlg* paramDlg;

        ULONG flags;
	    int rollScroll;

        enum 
        {
            //EXCLUSIVE_OBJECTS_REF = 0,
            //HIDDEN_OBJECTS_REF = 1,
            //CAMERA_REF = 2,
            //NUM_REFS = 3
            NUM_REFS = 0
        };

        /** Reference 0. */
	    //Texmap* renderTexture;

        /** Validity interval. */
        Interval ivalid;
    };
}


#endif