#ifndef OgreMax_OgreMaxRenderTextureDlg_INCLUDED
#define OgreMax_OgreMaxRenderTextureDlg_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class OgreMaxRenderTexture;

    /**
     * Manages the rollup(s) for an OgreMaxRenderTexture in the 3DS Max material editor.
     */
    class OgreMaxRenderTextureDlg : public ParamDlg 
    {
    public:
        OgreMaxRenderTextureDlg(HWND hWndMaterialEdit, IMtlParams* passParams, OgreMaxRenderTexture* pass); 
	    ~OgreMaxRenderTextureDlg();

	    Class_ID ClassID();
        void SetThing(ReferenceTarget* refTarget);
	    ReferenceTarget* GetThing();
	    void DeleteThis();
	    void SetTime(TimeValue t);
	    int FindSubTexFromHWND(HWND hWnd);
        
        /** Updates material and puts parameters into dialog. */
        void ReloadDialog();

        /** Called to notify the dialog it's being activated/deactiviated. */
        void ActivateDlg(BOOL activate);

        /**
         * Puts parameters into dialog.
         */
        void LoadDialog();

        /**
         * Loads the dialog resources and puts them into the dialog.
         */
        void BuildDialog();
        
    private:
        BOOL MainPanelProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

        static INT_PTR CALLBACK MainPanelDlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

    private:
        HWND hWndMaterialEdit;
        IMtlParams* renderTextureParams;
        OgreMaxRenderTexture* renderTexture;

        HWND mainPanel;
        
        TexDADMgr dragAndDropManager;	
        
        TimeValue currentTime;

        bool initialized;
    };
}


#endif
