#ifndef OgreMax_OgreMaxTechnique_INCLUDED
#define OgreMax_OgreMaxTechnique_INCLUDED


//Includes---------------------------------------------------------------------
#include "OgreMaxPasses.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class OgreMaxTechniqueDlg;

    class OgreMaxTechnique : public Texmap
    {
    public:
        enum 
        {
            ROLLUP_OPEN                 = 1<<28
        };

        OgreMaxTechnique(BOOL loading = FALSE);

        AColor EvalColor(ShadeContext& sc);
        Point3 EvalNormalPerturb(ShadeContext& sc);

        RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
	        PartID& partID, 
            RefMessage message
            );

        void Update(TimeValue t, Interval& valid);

        RefTargetHandle Clone(RemapDir& remap);
        void Reset();

        Interval Validity(TimeValue t);

        ParamDlg* CreateParamDlg(HWND hWndMaterialEdit, IMtlParams* materialParams);

        void SetParamDlg(OgreMaxTechniqueDlg* paramDlg);

        int NumSubTexmaps();
	    Texmap* GetSubTexmap(int i);
	    int MapSlotType(int i);
	    void SetSubTexmap(int i, Texmap* m);
	    TSTR GetSubTexmapSlotName(int i);
	    int SubTexmapOn(int i);

        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
        Class_ID ClassID();
	    SClass_ID SuperClassID();
	    void GetClassName(TSTR& s);
        void DeleteThis();

        TSTR SubAnimName(int i);
        int NumSubs();
        Animatable* SubAnim(int i);
        int NumRefs();
        RefTargetHandle GetReference(int i);
        void SetReference(int i, RefTargetHandle rtarg);
        
        ULONG GetFlags();
        void SetFlag(ULONG f, ULONG value);

        BOOL IsPassEnabled(int index);
        void EnablePass(int index, ULONG enable);

        TSTR GetPassName(int index);
        PassSlot* GetPass(int index);
        
        IOResult Save(ISave* isave);
        IOResult Load(ILoad* iload);

    public:
        OgreMaxTechniqueDlg* paramDlg;

        ULONG flags;
	    int rollScroll;

        enum 
        {
            PASSES_REF = 0,
            NUM_REFS = 1
        };

        /** Reference 0. */
	    OgreMaxPasses* passes;

        /** Validity interval. */
        Interval ivalid;
    };
}


#endif