#ifndef OgreMax_OgreMaxTechniqueDlg_INCLUDED
#define OgreMax_OgreMaxTechniqueDlg_INCLUDED


//Includes---------------------------------------------------------------------
#include "OgreMaxPasses.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class OgreMaxTechnique;

    /**
     * Manages the rollup(s) for an OgreMaxTechnique in the 3DS Max material editor.
     */
    class OgreMaxTechniqueDlg : public ParamDlg 
    {
    public:
        OgreMaxTechniqueDlg(HWND hWndMaterialEdit, IMtlParams* materialParams, OgreMaxTechnique* technique); 
	    ~OgreMaxTechniqueDlg();

	    Class_ID ClassID();
        void SetThing(ReferenceTarget* technique);
	    ReferenceTarget* GetThing();
	    void DeleteThis();
	    void SetTime(TimeValue t);
	    int FindSubTexFromHWND(HWND hWnd);
        
        /** Updates material and puts parameters into dialog. */
        void ReloadDialog();

        /** Called to notify the dialog it's being activated/deactiviated. */
        void ActivateDlg(BOOL activate);

        /**
         * Puts parameters into dialog.
         */
        void LoadDialog();

        /**
         * Loads the dialog resources and puts them into the dialog.
         */
        void BuildDialog();

        /**
         * Updates the information for the specified pass in the UI.
         * @param passIndex [in] - The index of the passto update in the UI.
         */
        void UpdatePassDisplay(int passIndex);

    private:
        BOOL MainPanelProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

        static INT_PTR CALLBACK MainPanelDlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

    private:
        HWND hWndMaterialEdit;
        IMtlParams* techniqueParams;
        OgreMaxTechnique* technique;

        HWND mainPanel;

        TexDADMgr dragAndDropManager;	
        ICustButton* passButton[OgreMaxPasses::MAX_PASSES];	    

        TimeValue currentTime;

        bool initialized;
    };
}


#endif
