#ifndef OgreMax_OgreMaxTechniques_INCLUDED
#define OgreMax_OgreMaxTechniques_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class TechniqueSlot 
    {
    public:
	    TechniqueSlot();

        BOOL IsOn();
        void SetOn(BOOL on);
        
        void Update(TimeValue t, Interval& ivalid);				
	    
        float GetDistance();
        void SetDistance(float distance);
	    
        BOOL HasMap();

        Texmap* GetMap();

        Control* GetDistanceControl();

    public:
        float distance;

        /** Reference to distance controller. */
        Control* distanceControl;  

        /** Reference to technique map. */
	    Texmap* map;
	    
        BOOL on;
	    
        TSTR name;
    };

    /**
     * The OgreMaxTechniques class is used by the 
     * OgreMaxMaterial class to manage its techniques, which are
     * implemented internally as Texmap objects.
     */
    class OgreMaxTechniques : public TexmapContainer 
    {
	public:  
        OgreMaxTechniques();
		OgreMaxTechniques(MtlBase* mtlBase);
		
        void SetName(long i, TSTR& name);
		TSTR& GetName(long i);
		
		void SetClientPtr(MtlBase* mtlBase);
		TechniqueSlot& operator[](int i);
        TechniqueSlot* GetTechnique(int i);

        /** Gets the ClassDesc for the OgreMaxTechniques class. */
        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
		Class_ID ClassID();
		void DeleteThis();
		
        RefTargetHandle Clone(RemapDir& remap = DefaultRemapDir());	
		RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
		    PartID& partID, 
            RefMessage message
            );

		void RescaleWorldUnits(float f);

		BOOL AssignController(Animatable* control, int subAnim);
        
		int NumSubs();
	    Animatable* SubAnim(int i);
		TSTR SubAnimName(int i);
		int SubNumToRefNum(int subNum);
        		
		int NumRefs();
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);

		SvGraphNodeReference SvTraverseAnimGraph
            (
            IGraphObjectManager* gom, 
            Animatable* owner, 
            int id, 
            DWORD flags
            );

		IOResult Save(ISave *isave);
		IOResult Load(ILoad *iload);

    public:
        MtlBase* client;
        
        enum {MAX_TECHNIQUES = 16};
		TechniqueSlot techniques[MAX_TECHNIQUES];
	};
}


#endif