#ifndef OgreMax_OgreMaxTextureUnit_INCLUDED
#define OgreMax_OgreMaxTextureUnit_INCLUDED


//Includes---------------------------------------------------------------------
#include "OgreMaxTextureUnits.h"
#include <vector>


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class OgreMaxTextureUnitDlg;

    class OgreMaxTextureUnit : public Texmap
    {
    public:
        enum 
        {
            ROLLUP_OPEN                 = 1<<28
        };

        enum
        {
            BITMAP_1D,
            BITMAP_2D,
            BITMAP_3D,
            BITMAP_CUBIC
        };

        enum
        {
            BLEND_FUNCTION_SOURCE1,
            BLEND_FUNCTION_SOURCE2,
            BLEND_FUNCTION_MODULATE,
            BLEND_FUNCTION_MODULATEX2,
            BLEND_FUNCTION_MODULATEX4,
            BLEND_FUNCTION_ADD_SIGNED,            
            BLEND_FUNCTION_ADD_SMOOTH,
            BLEND_FUNCTION_SUBTRACT,
            BLEND_FUNCTION_DIFFUSE_ALPHA,
            BLEND_FUNCTION_TEXTURE_ALPHA,
            BLEND_FUNCTION_CURRENT_ALPHA,
            BLEND_FUNCTION_MANUAL,
            BLEND_FUNCTION_DOT_PRODUCT
        };
        
        enum
        {
            BLEND_LOCATION_CURRENT,
            BLEND_LOCATION_TEXTURE,
            BLEND_LOCATION_DIFFUSE,
            BLEND_LOCATION_SPECULAR,
            BLEND_LOCATION_MANUAL
        };

        enum
        {
            ENVIRONMENT_MAPPING_OFF,
            ENVIRONMENT_MAPPING_PLANAR,
            ENVIRONMENT_MAPPING_SPHERICAL,
            ENVIRONMENT_MAPPING_REFLECTION,
            ENVIRONMENT_MAPPING_NORMAL
        };

        enum
        {
            ADDRESSING_MODE_WRAP,
            ADDRESSING_MODE_MIRROR,
            ADDRESSING_MODE_CLAMP
        };

        enum
        {
            FILTERING_MODE_NONE,
            FILTERING_MODE_BILINEAR,
            FILTERING_MODE_TRILINEAR,
            FILTERING_MODE_ANISOTROPIC
        };

        enum
        {
            TRANSFORM_ANIMATION_SCROLL_U,
            TRANSFORM_ANIMATION_SCROLL_V,
            TRANSFORM_ANIMATION_SCALE_U,
            TRANSFORM_ANIMATION_SCALE_V,
            TRANSFORM_ANIMATION_ROTATE
        };

        enum
        {
            TRANSFORM_ANIMATION_WAVE_SINE,
            TRANSFORM_ANIMATION_WAVE_TRIANGLE,
            TRANSFORM_ANIMATION_WAVE_SQUARE,
            TRANSFORM_ANIMATION_WAVE_SAWTOOTH,
            TRANSFORM_ANIMATION_WAVE_INVERSE
        };

        OgreMaxTextureUnit(BOOL loading = FALSE);

        void SetBitmapDimension(int value, TimeValue t = 0);;
        void SetMapChannel(int value, TimeValue t = 0);;
        void SetColorBlendFunction(int value, TimeValue t = 0);;
        void SetColorBlendSource(int value, TimeValue t = 0);;
        void SetColorBlendDestination(int value, TimeValue t = 0);;
        void SetColorBlendAlpha(float value, TimeValue t = 0);;
        void SetColorBlendManualColor1(Color value, TimeValue t = 0);;
        void SetColorBlendManualColor2(Color value, TimeValue t = 0);;
        void SetAlphaBlendFunction(int value, TimeValue t = 0);;
        void SetAlphaBlendSource(int value, TimeValue t = 0);;
        void SetAlphaBlendDestination(int value, TimeValue t = 0);;
        void SetAlphaBlendAlpha(float value, TimeValue t = 0);
        void SetAlphaBlendManualAlpha1(float value, TimeValue t = 0);;
        void SetAlphaBlendManualAlpha2(float value, TimeValue t = 0);;
        void SetLayerBlendFallbackSource(int value, TimeValue t = 0);;
        void SetLayerBlendFallbackDestination(int value, TimeValue t = 0);;
        void SetFramesDuration(float value, TimeValue t = 0);;
        void SetEnvironmentMapping(int value, TimeValue t = 0);;
        void SetAddressingMode(int value, TimeValue t = 0);;
        void SetFilteringMode(int value, TimeValue t = 0);;
        void SetMaxAnisotropy(int value, TimeValue t = 0);;
        void SetTransformScrollU(float value, TimeValue t = 0);;
        void SetTransformScrollV(float value, TimeValue t = 0);;
        void SetTransformScaleU(float value, TimeValue t = 0);;
        void SetTransformScaleV(float value, TimeValue t = 0);;
        void SetTransformRotate(float value, TimeValue t = 0);;
        void SetTransformAnimationScrollU(float value, TimeValue t = 0);;
        void SetTransformAnimationScrollV(float value, TimeValue t = 0);;
        void SetTransformAnimationRotate(float value, TimeValue t = 0);;
        void SetTransformAnimationType(int value, TimeValue t = 0);;
        void SetTransformAnimationWaveType(int value, TimeValue t = 0);;
        void SetTransformAnimationBase(float value, TimeValue t = 0);;
        void SetTransformAnimationFrequency(float value, TimeValue t = 0);;
        void SetTransformAnimationPhase(float value, TimeValue t = 0);;
        void SetTransformAnimationAmplitude(float value, TimeValue t = 0);;

        int GetBitmapDimension(TimeValue t = 0);
        int GetMapChannel(TimeValue t = 0);
        int GetColorBlendFunction(TimeValue t = 0);
        int GetColorBlendSource(TimeValue t = 0);
        int GetColorBlendDestination(TimeValue t = 0);
        float GetColorBlendAlpha(TimeValue t = 0);
        Color GetColorBlendManualColor1(TimeValue t = 0);
        Color GetColorBlendManualColor2(TimeValue t = 0);
        int GetAlphaBlendFunction(TimeValue t = 0);
        int GetAlphaBlendSource(TimeValue t = 0);
        int GetAlphaBlendDestination(TimeValue t = 0);
        float GetAlphaBlendAlpha(TimeValue t = 0);
        float GetAlphaBlendManualAlpha1(TimeValue t = 0);
        float GetAlphaBlendManualAlpha2(TimeValue t = 0);
        int GetLayerBlendFallbackSource(TimeValue t = 0);
        int GetLayerBlendFallbackDestination(TimeValue t = 0);
        float GetFramesDuration(TimeValue t = 0);
        int GetEnvironmentMapping(TimeValue t = 0);
        int GetAddressingMode(TimeValue t = 0);
        int GetFilteringMode(TimeValue t = 0);
        int GetMaxAnisotropy(TimeValue t = 0);
        float GetTransformScrollU(TimeValue t = 0);
        float GetTransformScrollV(TimeValue t = 0);
        float GetTransformScaleU(TimeValue t = 0);
        float GetTransformScaleV(TimeValue t = 0);
        float GetTransformRotate(TimeValue t = 0);
        float GetTransformAnimationScrollU(TimeValue t = 0);
        float GetTransformAnimationScrollV(TimeValue t = 0);
        float GetTransformAnimationRotate(TimeValue t = 0);
        int GetTransformAnimationType(TimeValue t = 0);
        int GetTransformAnimationWaveType(TimeValue t = 0);
        float GetTransformAnimationBase(TimeValue t = 0);
        float GetTransformAnimationFrequency(TimeValue t = 0);
        float GetTransformAnimationPhase(TimeValue t = 0);
        float GetTransformAnimationAmplitude(TimeValue t = 0);

        AColor EvalColor(ShadeContext& sc);
        Point3 EvalNormalPerturb(ShadeContext& sc);

        RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
	        PartID& partID, 
            RefMessage message
            );

        void Update(TimeValue t, Interval& valid);

        RefTargetHandle Clone(RemapDir& remap);
        void Reset();

        Interval Validity(TimeValue t);

        ParamDlg* CreateParamDlg(HWND hWndMaterialEdit, IMtlParams* materialParams);

        void SetParamDlg(OgreMaxTextureUnitDlg* paramDlg);

        int NumSubTexmaps();
	    Texmap* GetSubTexmap(int i);
	    int MapSlotType(int i);
	    void SetSubTexmap(int i, Texmap* m);
	    TSTR GetSubTexmapSlotName(int i);
	    int SubTexmapOn(int i);

        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
        Class_ID ClassID();
	    SClass_ID SuperClassID();
	    void GetClassName(TSTR& s);
        void DeleteThis();

        TSTR SubAnimName(int i);
        int NumSubs();
        Animatable* SubAnim(int i);
        int NumRefs();
        RefTargetHandle GetReference(int i);
        void SetReference(int i, RefTargetHandle rtarg);
        
        ULONG GetFlags();
        void SetFlag(ULONG f, ULONG value);

        TSTR GetRenderTextureName();
        TSTR GetBitmapFileName();

        void AddFrame(TSTR fileName);
        void RemoveFrame(int index);
        const TSTR* GetFrames();
        int GetFrameCount();
        const TSTR& GetFrame(int index);

        IOResult Save(ISave* isave);
        IOResult Load(ILoad* iload);

    public:
        OgreMaxTextureUnitDlg* paramDlg;

        ULONG flags;
	    int rollScroll;

        /** Reference indices. */
        enum 
        {
            RENDER_TEXTURE_REF = 0,
            PARAM_BLOCK_REF = 1,
            NUM_REFS = 2
        };

        /** Sub texmap indices. */
        enum
        {
            RENDER_TEXTURE_SUBTEXMAP = 0,
            NUM_SUBTEXMAPS = 1
        };

        /** ParamBlock indices. */
        enum
        {
            PB_BITMAP_DIMENSION = 0,
            PB_MAP_CHANNEL = 1,
            PB_COLOR_BLEND_FUNCTION = 2,
            PB_COLOR_BLEND_SOURCE = 3,
            PB_COLOR_BLEND_DESTINATION = 4,
            PB_COLOR_BLEND_ALPHA = 5,
            PB_COLOR_BLEND_MANUAL_COLOR1 = 6,
            PB_COLOR_BLEND_MANUAL_COLOR2 = 7,
            PB_ALPHA_BLEND_FUNCTION = 8,
            PB_ALPHA_BLEND_SOURCE = 9,
            PB_ALPHA_BLEND_DESTINATION = 10,
            PB_ALPHA_BLEND_ALPHA = 11,
            PB_ALPHA_BLEND_MANUAL_ALPHA1 = 12,
            PB_ALPHA_BLEND_MANUAL_ALPHA2 = 13,
            PB_LAYER_BLEND_FALLBACK_SOURCE = 14,
            PB_LAYER_BLEND_FALLBACK_DESTINATION = 15,
            PB_FRAMES_DURATION = 16,
            PB_ENVIRONMENT_MAPPING = 17,
            PB_ADDRESSING_MODE = 18,
            PB_FILTERING_MODE = 19,
            PB_MAX_ANISOTROPY = 20,
            PB_TRANSFORM_SCROLL_U = 21,
            PB_TRANSFORM_SCROLL_V = 22,
            PB_TRANSFORM_SCALE_U = 23,
            PB_TRANSFORM_SCALE_V = 24,
            PB_TRANSFORM_ROTATE = 25,
            PB_TRANSFORM_ANIMATION_SCROLL_U = 26,
            PB_TRANSFORM_ANIMATION_SCROLL_V = 27,
            PB_TRANSFORM_ANIMATION_ROTATE = 28,
            PB_TRANSFORM_ANIMATION_TRANSFORM_TYPE = 29,
            PB_TRANSFORM_ANIMATION_WAVE_TYPE = 30,
            PB_TRANSFORM_ANIMATION_BASE = 31,
            PB_TRANSFORM_ANIMATION_FREQUENCY = 32,
            PB_TRANSFORM_ANIMATION_PHASE = 33,
            PB_TRANSFORM_ANIMATION_AMPLITUDE = 34,
            NUM_PB_ENTRIES = 35
        };

        /** Reference 0. */
	    Texmap* renderTexture;

        /** Reference 1. */
        IParamBlock* paramBlock;

        /** Validity interval. */
        Interval ivalid;

        TSTR bitmapFileName;        

        std::vector<TSTR> frameFileNames;
    };
}


#endif