#ifndef OgreMax_OgreMaxTextureUnits_INCLUDED
#define OgreMax_OgreMaxTextureUnits_INCLUDED


//Includes---------------------------------------------------------------------


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class TextureUnitSlot 
    {
    public:
	    TextureUnitSlot();

        BOOL IsOn();
        void SetOn(BOOL on);
        
        void Update(TimeValue t, Interval& ivalid);				
	    
        BOOL HasMap();

        Texmap* GetMap();

    public:
        /** Reference to technique map. */
	    Texmap* map;
	    
        BOOL on;
	    
        TSTR name;
    };

    /**
     * The OgreMaxTextureUnits class is used by the 
     * OgreMaxPass class to manage its texture units, which are
     * implemented internally as Texmap objects.
     */
    class OgreMaxTextureUnits : public TexmapContainer 
    {
	public:  
        OgreMaxTextureUnits();
		OgreMaxTextureUnits(MtlBase* mtlBase);
		
        void SetName(long i, TSTR& name);
		TSTR& GetName(long i);
		
		void SetClientPtr(MtlBase* mtlBase);
		TextureUnitSlot& operator[](int i);
        TextureUnitSlot* GetTextureUnit(int i);

        /** Gets the ClassDesc for the OgreMaxTextureUnits class. */
        static ClassDesc* GetClassDesc();
        static Class_ID GetClassClassID();
		Class_ID ClassID();
		void DeleteThis();
		
        RefTargetHandle Clone(RemapDir& remap = DefaultRemapDir());	
		RefResult NotifyRefChanged
            (
            Interval changeInt, 
            RefTargetHandle hTarget, 
		    PartID& partID, 
            RefMessage message
            );

		void RescaleWorldUnits(float f);

		BOOL AssignController(Animatable* control, int subAnim);
        
		int NumSubs();
	    Animatable* SubAnim(int i);
		TSTR SubAnimName(int i);
		int SubNumToRefNum(int subNum);
        		
		int NumRefs();
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);

		SvGraphNodeReference SvTraverseAnimGraph
            (
            IGraphObjectManager* gom, 
            Animatable* owner, 
            int id, 
            DWORD flags
            );

		IOResult Save(ISave *isave);
		IOResult Load(ILoad *iload);

    public:
        MtlBase* client;
        
        enum {MAX_TEXTURE_UNITS = 4};
		TextureUnitSlot textureUnits[MAX_TEXTURE_UNITS];
	};
}


#endif