#ifndef OGRE_XMLCONVERTER_INCLUDED
#define OGRE_XMLCONVERTER_INCLUDED

namespace Ogre 
{
    struct XmlOptions
    {
        XmlOptions()
        {
            interactiveMode = false;            
        }

        Ogre::String source;
        Ogre::String dest;
        Ogre::String sourceExt;
        Ogre::String destExt;
        Ogre::String logFile;
        bool interactiveMode;
        unsigned short numLods;
        Ogre::Real lodDist;
        Ogre::Real lodPercent;
        size_t lodFixed;
        size_t nuextremityPoints;
        bool usePercent;
        bool generateEdgeLists;
        bool generateTangents;
        Ogre::VertexElementSemantic tangentSemantic;
        bool reorganiseBuffers;
	    bool optimiseAnimations;
	    bool quietMode;
	    bool d3d;
	    bool gl;
	    Ogre::Serializer::Endian endian;
    };

    class XMLConverter
    {
    public:
        static void Convert(XmlOptions& options);
    };
}


#endif