
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "PhysicsExporter.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
PhysicsExporter::PhysicsExporter()
{
    this->physicsExportType = NO_PHYSICS;
    this->sceneXmlElement = 0;
    this->opalSimulatorInfoXmlElement = 0;
}

PhysicsExporter::PhysicsExporter(PhysicsExportType physicsExportType)
{
    this->sceneXmlElement = 0;
    SetPhysicsExportType(physicsExportType);
}

TiXmlElement* PhysicsExporter::GetRootNodeXmlElement()
{
    return this->sceneXmlElement;
}

TiXmlElement* PhysicsExporter::GetOpalSimulatorInfoElement()
{
    if (this->physicsExportType == OPAL_PHYSICS && 
        this->opalSimulatorInfoXmlElement == 0)
    {
        this->opalSimulatorInfoXmlElement = 
            (TiXmlElement*)GetRootNodeXmlElement()->LinkEndChild(new TiXmlElement("SimulatorInfo"));
    }

    return this->opalSimulatorInfoXmlElement;
}

PhysicsExportType PhysicsExporter::GetPhysicsExportType() const
{
    return this->physicsExportType;
}

void PhysicsExporter::SetPhysicsExportType(PhysicsExportType physicsExportType)
{
    if (this->sceneXmlElement == 0)
    {
        this->physicsExportType = physicsExportType;

        if (this->physicsExportType == OPAL_PHYSICS)
            this->sceneXmlElement = (TiXmlElement*)this->sceneXmlDocument.LinkEndChild(new TiXmlElement(_T("OpalBlueprint")));            
        else
            this->sceneXmlElement = (TiXmlElement*)this->sceneXmlDocument.LinkEndChild(new TiXmlElement(_T("NotUsed")));    
    }
}

bool PhysicsExporter::Save(const TSTR& baseFilePath)
{
    if (this->sceneXmlElement != 0)
    {
        if (this->physicsExportType == OPAL_PHYSICS)
        {
            TSTR physicsFileName = baseFilePath + _T(".physics.opal");
            this->sceneXmlDocument.SaveFile(physicsFileName);
            return true;
        }
    }

    return false;
}