#ifndef OgreMax_PhysicsExporter_INCLUDED
#define OgreMax_PhysicsExporter_INCLUDED


//Includes---------------------------------------------------------------------
#include "ExportSettings.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    class PhysicsExporter
    {
    public:
        PhysicsExporter();
        PhysicsExporter(PhysicsExportType physicsExportType);

        TiXmlElement* GetRootNodeXmlElement();

        TiXmlElement* GetOpalSimulatorInfoElement();

        PhysicsExportType GetPhysicsExportType() const;
        void SetPhysicsExportType(PhysicsExportType physicsExportType);

        bool Save(const TSTR& baseFilePath);

    private:
        TiXmlDocument sceneXmlDocument;

        /** Pointer to the root 'scene' element */
	    TiXmlElement* sceneXmlElement;

        TiXmlElement* opalSimulatorInfoXmlElement;

        PhysicsExportType physicsExportType;
    };
}


#endif