
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "PluginGlobals.h"
#include "OgreMaxGlobalUtilities.h"
#include "OgreMaxSceneExporter.h"
#include "OgreMaxMaterial.h"
#include "OgreMaxTechniques.h"
#include "OgreMaxTechnique.h"
#include "OgreMaxPasses.h"
#include "OgreMaxPass.h"
#include "OgreMaxTextureUnits.h"
#include "OgreMaxTextureUnit.h"
#include "OgreMaxRenderTexture.h"

using namespace OgreMax;


//Static initialization--------------------------------------------------------
HINSTANCE PluginGlobals::hInstance = NULL;
FileVersionInfo PluginGlobals::versionInfo;
const TSTR PluginGlobals::CONTROL_NEWLINE(_T("\r\n"));
const TSTR PluginGlobals::OgreMaxUserPropertyMarker(_T("--OgreMax--"));
const TSTR PluginGlobals::OgreMaxUserDataPropertyMarker(_T("--OgreMaxUserData--"));
ClassDesc* PluginGlobals::classDescriptions[] = {0};
int PluginGlobals::classDescriptionCount = 0;


//Implementation---------------------------------------------------------------
TCHAR* PluginGlobals::GetString(int id)
{
	static TCHAR buffer[MAX_GET_STRING_LENGTH + 1];

	if (hInstance)
	{
		if (LoadString(hInstance, id, buffer, sizeof(buffer)))
			return buffer;
	}

	return NULL;
}

TCHAR* PluginGlobals::GetString2(int id)
{
	static TCHAR buffer[MAX_GET_STRING_LENGTH + 1];

	if (hInstance)
	{
		if (LoadString(hInstance, id, buffer, sizeof(buffer)))
			return buffer;
	}

	return NULL;
}

HINSTANCE PluginGlobals::GetInstanceHandle()
{
	return hInstance;
}

void PluginGlobals::Initialize(HINSTANCE hInstance)
{
	PluginGlobals::hInstance = hInstance;

    versionInfo.Create(hInstance);

	//3DS Max custom controls initialization
	InitCustomControls(hInstance);	

	//Initialize Explorer-style controls
	InitCommonControls();

    //Set up the ClassDesc array
    classDescriptions[classDescriptionCount++] = OgreMaxGlobalUtilities::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxSceneExporter::GetClassDesc();

#if 0
    classDescriptions[classDescriptionCount++] = OgreMaxMaterial::GetClassDesc();        
    classDescriptions[classDescriptionCount++] = OgreMaxTechniques::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxTechnique::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxPasses::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxPass::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxTextureUnits::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxTextureUnit::GetClassDesc();
    classDescriptions[classDescriptionCount++] = OgreMaxRenderTexture::GetClassDesc();
#endif
}

int PluginGlobals::GetClassDescriptionCount()
{
    return classDescriptionCount;
}

ClassDesc* PluginGlobals::GetClassDescription(size_t index)
{
    return classDescriptions[index];
}