#ifndef OgreMax_PropertyKeys_INCLUDED
#define OgreMax_PropertyKeys_INCLUDED


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    struct PropertyKeys
    {
        static const TSTR ID;
        static const TSTR NAME;

        static const TSTR USER_DATA_REFERENCE;
        static const TSTR USER_DATA_MARKER;        
        static const TSTR IS_USER_DATA_CDATA;

        static const TSTR TYPE;
        static const TSTR GRAPHICS_TYPE;
        static const TSTR IGNORE_CHILDREN;
        static const TSTR CHILD_SORTING;
        static const TSTR CHILD_ORDER;

        static const TSTR IS_MODEL;
        static const TSTR MODEL_NAME;
        
        static const TSTR SCENE_MANAGER;
        static const TSTR EXPORT_SETTINGS_FILE;

        static const TSTR EXPORT_PHYSICS;
        static const TSTR PHYSICS_ENABLED;
        static const TSTR PHYSICS_SHAPE;
        static const TSTR PHYSICS_SPACE_TYPE;
        static const TSTR PHYSICS_SPACE_HASH_MIN_LEVEL;
        static const TSTR PHYSICS_SPACE_HASH_MAX_LEVEL;
        static const TSTR PHYSICS_SPACE_OCTREE_DEPTH;
        static const TSTR CONTACT_GROUP_SETUP_COUNT;
        static const TSTR CONTACT_GROUP_SETUP_FORMAT;
        static const TSTR CONTACT_GROUP;
        static const TSTR SLEEPINESS;
        static const TSTR LINEAR_DAMPING;
        static const TSTR ANGULAR_DAMPING;
        static const TSTR MAKE_UPRIGHT;
        static const TSTR HAS_VOLUME_SENSOR;
        static const TSTR VOLUME_SENSOR_NAME;
        static const TSTR HAS_ACCELERATION_SENSOR;
        static const TSTR ACCELERATION_SENSOR_NAME;
        static const TSTR HAS_INCLINE_SENSOR;
        static const TSTR INCLINE_SENSOR_NAME;
        static const TSTR BREAK_MODE;
        static const TSTR CONTACTS_ENABLED;
        static const TSTR BODY;
        static const TSTR MODE;
        static const TSTR LINEAR_KD;
        static const TSTR LINEAR_KS;
        static const TSTR ANGULAR_KD;
        static const TSTR ANGULAR_KS;
        static const TSTR SOLID_REFERENCE;

        static const TSTR SHADOW_TECHNIQUE;
        static const TSTR SELF_SHADOW;
        static const TSTR SHADOW_COLOR;
        static const TSTR SHADOW_TEXTURE_SIZE;
        static const TSTR SHADOW_TEXTURE_COUNT;
        static const TSTR SHADOW_CAMERA_TYPE;
        static const TSTR SHADOW_PLANE;

        static const TSTR ENVIRONMENT_NEAR;
        static const TSTR ENVIRONMENT_FAR;
        static const TSTR ENVIRONMENT_BOX;
        static const TSTR FOG_MODE;
        static const TSTR FOG_EXP_DENSITY;

        static const TSTR VISIBILITY;
        static const TSTR TARGET_TYPE;

        static const TSTR IS_STATIC;
        static const TSTR FILE;
        static const TSTR RENDER_QUEUE;

        static const TSTR BILLBOARD_SET_TYPE;
        static const TSTR ORIGIN;
        static const TSTR COMMON_DIRECTION;
        static const TSTR COMMON_UP_VECTOR;
        static const TSTR ROTATION_TYPE;

        static const TSTR DIFFUSE_COLOR;
        
        static const TSTR NUM_TEX_COORD_SETS;

        static const TSTR NORMALS;

        static const TSTR ANIMATION_NAME;
        static const TSTR ANIMATION_ENABLED;
        static const TSTR ANIMATION_LOOPED;

        static const TSTR NOTE_TRACK_NAME;
        static const TSTR NOTE_TRACK_NAME_FORMAT;

        static const TSTR ITEM_TYPE;

        static const TSTR ENABLE;
        
        static const TSTR DRAW_FIRST;
        static const TSTR CURVATURE;

        static const TSTR SCALE;
        static const TSTR BOW;

        static const TSTR VERTEX_ANIMATION_TYPE;
        static const TSTR SKELETON_NAME;
        static const TSTR SIMPLE_MESH;
        
        static const TSTR REMOVE_BONE_TRANSLATION_FORMAT;
        static const TSTR REMOVE_BONE_TRANSLATION;

        static const TSTR VERTEX_ANIMATION_SAMPLE_INTERVAL;
        static const TSTR VERTEX_ANIMATION_SAMPLE_RATE;
        static const TSTR SKELETON_ANIMATION_SAMPLE_INTERVAL;
        static const TSTR SKELETON_ANIMATION_SAMPLE_RATE;
        static const TSTR MESH_ANIMATION_SAMPLE_INTERVAL;
        static const TSTR MESH_ANIMATION_SAMPLE_RATE;
        static const TSTR SAMPLE_INTERVAL;
        static const TSTR SAMPLE_RATE;
        static const TSTR COPY_FIRST_KEY_TO_LAST;
        static const TSTR EXPORT_BONE_TREE;
        static const TSTR EXPORT_BONE;

        static const TSTR EXPORT_MATERIAL;
        static const TSTR EXPORT_MESH;
        static const TSTR RENAME_BITMAP;
        static const TSTR RENAME_BITMAP_EXTENSION;
        static const TSTR MESH_NAME;
        
        static const TSTR VERTEX_BUFFER_USAGE;
        static const TSTR VERTEX_BUFFER_USE_SHADOW;
        static const TSTR INDEX_BUFFER_USAGE;
        static const TSTR INDEX_BUFFER_USE_SHADOW;    
        static const TSTR USAGE;
        static const TSTR USE_SHADOW;

        static const TSTR LENGTH;

        static const TSTR MATERIAL_TYPE;
        static const TSTR MATERIAL_HARDNESS;
        static const TSTR MATERIAL_FRICTION;
        static const TSTR MATERIAL_BOUNCINESS;
        static const TSTR MATERIAL_DENSITY;

        static const TSTR JOINT_AXIS_FORMAT;
        static const TSTR JOINT_AXIS;

        static const TSTR GENERATE_LOD;
        static const TSTR NUM_LOD_LEVELS;
        static const TSTR LOD_DISTANCE;
        static const TSTR LOD_REDUCTION_TYPE;
        static const TSTR LOD_PERCENT_REDUCTION;
        static const TSTR LOD_VERTEX_REDUCTION;
        static const TSTR LOD_REDUCTION_AMOUNT;

        static const TSTR EXPORT_MESHES;
        static const TSTR EXPORT_MATERIALS;
        static const TSTR PHYSICS_EXPORT_TYPE;
        static const TSTR EXPORT_VERTEX_COLORS;
        static const TSTR UP_AXIS;
        static const TSTR TEX_COORD_2D;
        static const TSTR NO_MATERIAL_NAME;
        static const TSTR SORT_BONE_ASSIGNMENTS;
        static const TSTR EXPORT_TEXT_MESH;
        static const TSTR EXPORT_BINARY_MESH;
        static const TSTR GENERATE_TANGENTS;
        static const TSTR GENERATE_EDGE_LISTS;
        static const TSTR VERTEX_COLOR_FORMAT;
        static const TSTR ENDIAN;

        static const TSTR EXPORT_PATH;
        static const TSTR MESH_PATH;
        static const TSTR MATERIAL_PATH;
        static const TSTR MODEL_PATH;
        static const TSTR LOG_PATH;
        static const TSTR MATERIAL_FILE_NAME;        
    };
}


#endif
