#ifndef OgreMax_PropertyValues_INCLUDED
#define OgreMax_PropertyValues_INCLUDED


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    struct PropertyValues
    {
        static const TSTR TRUE_TEXT;
        static const TSTR FALSE_TEXT;

        struct ObjectType
        {
            static const TSTR IGNORE_OBJECT; //Can't use IGNORE because it's a Windows macro
            static const TSTR EMPTY;
            static const TSTR ENTITY;
            static const TSTR LIGHT;
            static const TSTR CAMERA;
            static const TSTR EXTERNAL;
            static const TSTR TERRAIN;
            static const TSTR SKY_BOX;
            static const TSTR SKY_DOME;
            static const TSTR SKY_PLANE;
            static const TSTR PARTICLE_SYSTEM;
            static const TSTR BILLBOARD_SET;
            static const TSTR BILLBOARD;
            static const TSTR MODEL_INSTANCE;        
            static const TSTR PLANE;        
        };

        struct MeshAnimationType
        {
            static const TSTR MORPH_ONLY;
            static const TSTR MORPH;
            static const TSTR POSE;
        };

        struct Visibility
        {
            static const TSTR VISIBLE;
            static const TSTR HIDDEN;
            static const TSTR TREE_VISIBLE;
            static const TSTR TREE_HIDDEN;
        };

        struct RenderQueue
        {
            static const TSTR BACKGROUND;
            static const TSTR SKIES_EARLY;
            static const TSTR QUEUE1;
            static const TSTR QUEUE2;
            static const TSTR WORLD_GEOMETRY1;
            static const TSTR QUEUE3;
            static const TSTR QUEUE4;
            static const TSTR MAIN;
            static const TSTR QUEUE6;
            static const TSTR QUEUE7;
            static const TSTR WORLD_GEOMETRY2;
            static const TSTR QUEUE8;
            static const TSTR QUEUE9;
            static const TSTR SKIES_LATE;
            static const TSTR OVERLAY;
            static const TSTR MAX;
        };

        struct ChildSorting
        {
            static const TSTR NAME;
            static const TSTR ID;
            static const TSTR ID_NUMBER;
            static const TSTR CHILD_ORDER;
        };

        struct BillboardSetType
        {
            static const TSTR POINT;
            static const TSTR ORIENTED_COMMON;
            static const TSTR ORIENTED_SELF;
            static const TSTR PERPENDICULAR_COMMON;
            static const TSTR PERPENDICULAR_SELF;
        };

        struct BillboardOrigin
        {
            static const TSTR CENTER;
            static const TSTR TOP_LEFT;
            static const TSTR TOP_CENTER;
            static const TSTR TOP_RIGHT;
            static const TSTR CENTER_RIGHT;
            static const TSTR BOTTOM_RIGHT;
            static const TSTR BOTTOM_CENTER;
            static const TSTR BOTTOM_LEFT;
            static const TSTR CENTER_LEFT;
        };

        struct BillboardRotationType
        {
            static const TSTR VERTEX;
            static const TSTR TEX_COORD;
        };

        struct HardwareBufferUsage
        {
            static const TSTR STATIC;
            static const TSTR DYNAMIC;
            static const TSTR WRITE_ONLY;
            static const TSTR STATIC_WRITE_ONLY;
            static const TSTR DYNAMIC_WRITE_ONLY;            
        };

        struct LODReductionType
        {
            static const TSTR VERTEX;
            static const TSTR PERCENT;
        };

        struct UpAxis
        {
            static const TSTR Y_UP;
            static const TSTR Z_UP;
        };

        struct SceneScale
        {
            static const TSTR STANDARD;
            static const TSTR ACTIVE;
            static const TSTR METERS;
            static const TSTR KILOMETERS;
            static const TSTR FEET;
            static const TSTR MILES;
        };

        struct StandardSceneManager
        {
            static const TSTR GENERIC;        
            static const TSTR EXTERIOR_CLOSE;
            static const TSTR EXTERIOR_FAR;
            static const TSTR EXTERIOR_REAL_FAR;
        };

        struct VertexColorFormat
        {
            static const TSTR DIRECT3D;
            static const TSTR OPENGL;
        };

        struct ByteOrder
        {
            static const TSTR NATIVE;
            static const TSTR LITTLE_ENDIAN;
            static const TSTR BIG_ENDIAN;
        };

        struct ShadowTechnique
        {
            static const TSTR NONE;
            static const TSTR STENCIL_MODULATIVE;
            static const TSTR STENCIL_ADDITIVE;
            static const TSTR TEXTURE_MODULATIVE;
            static const TSTR TEXTURE_ADDITIVE;
            static const TSTR TEXTURE_MODULATIVE_INTEGRATED;
            static const TSTR TEXTURE_ADDITIVE_INTEGRATED;
        };

        struct ShadowCameraType
        {
            static const TSTR UNIFORM;
            static const TSTR UNIFORM_FOCUSED;
            static const TSTR LISPSM;
            static const TSTR PLANE_OPTIMAL;
        };

        struct TimeScale
        {
            static const TSTR NORMALIZE;
        };

        struct FogMode
        {
            static const TSTR LINEAR;
            static const TSTR EXP;
            static const TSTR EXP2;
        };
    };
}


#endif