
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "RemoveBoneTranslationsDialog.h"
#include "Utilities.h"
#include "PluginGlobals.h"
#include "resource.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
RemoveBoneTranslationsDialog::RemoveBoneTranslationsDialog()
{
}

RemoveBoneTranslationsDialog::~RemoveBoneTranslationsDialog()
{
}

int RemoveBoneTranslationsDialog::DoModal(HWND hWndParent)
{
    return DialogBase::DoModal(IDD_REMOVE_BONE_TRANSLATIONS_DIALOG, hWndParent);
}

INT_PTR RemoveBoneTranslationsDialog::DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled)
{
    switch (message)
    {
        case WM_INITDIALOG:
        {
            //Center in parent window
            CenterWindow();

            handled = true;

            break;
        }
        case WM_COMMAND:
        {
            int id = LOWORD(wParam);
            int code = HIWORD(wParam);

            switch (id)
            {
                case IDOK:
                {
                    GetDlgItemText(IDC_BONE_NAME_EDIT, this->boneName);

                    handled = true;

                    this->xyz = _T("");
                    if (IsDlgButtonChecked(IDC_NODE_REMOVE_BONE_TRANSLATION_X_CHECK))
                        this->xyz += _T("x");
                    if (IsDlgButtonChecked(IDC_NODE_REMOVE_BONE_TRANSLATION_Y_CHECK))
                        this->xyz += _T("y");
                    if (IsDlgButtonChecked(IDC_NODE_REMOVE_BONE_TRANSLATION_Z_CHECK))
                        this->xyz += _T("z");

                    if (this->boneName.isNull())
                    {
                        Utilities::ShowMessage(PluginGlobals::GetString(IDS_BONE_NAME_REQUIRED), PluginGlobals::GetString2(IDS_DATA_ENTRY_ERROR), MB_ICONINFORMATION | MB_OK);
                        SetFocus(GetDlgItem(IDC_BONE_NAME_EDIT));
                    }
                    else if (this->xyz.isNull())
                        Utilities::ShowMessage(PluginGlobals::GetString(IDS_REMOVE_TRANSLATION_COMPONENT_REQUIRED), PluginGlobals::GetString2(IDS_DATA_ENTRY_ERROR), MB_ICONINFORMATION | MB_OK);
                    else
                        EndDialog(this->hDlg, TRUE);
                    return TRUE;
                }
                case IDCANCEL:
                {
                    handled = true;
                    EndDialog(this->hDlg, FALSE);
                    return FALSE;
                }                
            }

            break;
        }        
    }

    return 0;
}