
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "RenameDialog.h"
#include "Utilities.h"
#include "PluginGlobals.h"
#include "resource.h"

using namespace OgreMax;


//Implementation---------------------------------------------------------------
RenameDialog::RenameDialog()
{
}

int RenameDialog::DoModal(HWND hWndParent)
{
    return DialogBase::DoModal(IDD_RENAME_DIALOG, hWndParent);
}

INT_PTR RenameDialog::DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled)
{
    switch (message)
    {
        case WM_INITDIALOG:
        {
            //Set window title
            if (!this->title.isNull())
                SetWindowText(this->title);

            //Set edit values
            SetDlgItemText(IDC_FROM_EDIT, this->from);
            SetDlgItemText(IDC_TO_EDIT, this->to);

            //Center in parent window
            CenterWindow();

            handled = true;

            break;
        }
        case WM_COMMAND:
        {
            int id = LOWORD(wParam);
            int code = HIWORD(wParam);

            switch (id)
            {
                case IDOK:
                {
                    GetDlgItemText(IDC_FROM_EDIT, this->from);
                    GetDlgItemText(IDC_TO_EDIT, this->to);

                    handled = true;

                    if (this->from.isNull())
                    {
                        Utilities::ShowMessage(PluginGlobals::GetString(IDS_FROM_FIELD_REQUIRED), PluginGlobals::GetString2(IDS_DATA_ENTRY_ERROR), MB_ICONINFORMATION | MB_OK);
                        SetFocus(GetDlgItem(IDC_FROM_EDIT));
                    }
                    else if (this->to.isNull())
                    {
                        Utilities::ShowMessage(PluginGlobals::GetString(IDS_TO_FIELD_REQUIRED), PluginGlobals::GetString2(IDS_DATA_ENTRY_ERROR), MB_ICONINFORMATION | MB_OK);
                        SetFocus(GetDlgItem(IDC_TO_EDIT));
                    }
                    else                    
                        EndDialog(this->hDlg, TRUE);

                    return TRUE;
                }
                case IDCANCEL:
                {
                    handled = true;
                    EndDialog(this->hDlg, FALSE);
                    return FALSE;
                }
            }

            break;
        }
    }

    return 0;
}