
#ifndef OgreMax_SceneSettingsDialog_INCLUDED
#define OgreMax_SceneSettingsDialog_INCLUDED


//Includes---------------------------------------------------------------------
#include "DialogBase.h"
#include "TabControl.h"
#include "SceneSettingsTabPages.h"
#include "UserDataTabPage.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{    
    class SceneSettingsDialog : public DialogBase
    {
    public:
        SceneSettingsDialog(SceneSettings& settings);
        ~SceneSettingsDialog();

        int DoModal();

    protected:
        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

        TabControl tabControl;
        std::vector<DialogBase*> tabPages;

        SceneSettingsGeneralTabPage generalTabPage;
        UserDataTabPage userDataTabPage;
        SceneSettingsMeshesTabPage meshesTabPage;
        SceneSettingsMaterialsTabPage materialsTabPage;
        SceneSettingsBitmapsTabPage bitmapsTabPage;
        SceneSettingsShadowsTabPage shadowsTabPage;
        SceneSettingsDirectoriesTabPage directoriesTabPage;

        SceneSettings& settings;
    };
}

#endif

