#ifndef OgreMax_SceneSettingsTabPages_INCLUDED
#define OgreMax_SceneSettingsTabPages_INCLUDED


//Includes---------------------------------------------------------------------
#include "DialogBase.h"
#include "SceneSettings.h"


//Classes----------------------------------------------------------------------
namespace OgreMax
{    
    /** Scene settings "General" tab page */
    class SceneSettingsGeneralTabPage : public DialogBase
    {
    public:
        SceneSettingsGeneralTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);
        void Detach();

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;
        ISpinnerControl* nearDistanceSpin;
        ISpinnerControl* farDistanceSpin;
    };

    /** Scene settings "Meshes" tab page */
    class SceneSettingsMeshesTabPage : public DialogBase
    {
    public:
        SceneSettingsMeshesTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);
        void Detach();

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;
        ISpinnerControl* lodDistanceSpin;
    };

    /** Scene settings "Materials" tab page */
    class SceneSettingsMaterialsTabPage : public DialogBase
    {
    public:
        SceneSettingsMaterialsTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;
    };

    /** Scene settings "Bitmaps" tab page */
    class SceneSettingsBitmapsTabPage : public DialogBase
    {
    public:
        SceneSettingsBitmapsTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;
    };

    /** Scene settings "Shadows" tab page */
    class SceneSettingsShadowsTabPage : public DialogBase
    {
    public:
        SceneSettingsShadowsTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);
        void Detach();

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;

        IColorSwatch* colorSwatch;
    };

    /** Scene settings "Directories" tab page */
    class SceneSettingsDirectoriesTabPage : public DialogBase
    {
    public:
        SceneSettingsDirectoriesTabPage(SceneSettings& settings);

        void Attach(HWND hDlg);

        void GetGUIData();

    protected:
        void SetGUIData();

        INT_PTR DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled);

    private:        
        SceneSettings& settings;
    };
}

#endif

