
#ifndef OgreMax_StringSplitter_INCLUDED
#define OgreMax_StringSplitter_INCLUDED


//Includes---------------------------------------------------------------------
#include <vector>
#include <string>


//Classes----------------------------------------------------------------------
namespace OgreMax
{
    /** Utility class for splitting and rejoining strings */
    class StringSplitter : public std::vector<TSTR>
    {	    
    public:
        StringSplitter();
        StringSplitter(const TSTR& strToSplit, TCHAR splitChar);
	    StringSplitter(const TCHAR* strToSplit, TCHAR splitChar);

        int FindLine(const TSTR& text, int startLine = 0) const;
	  
        size_t TotalLength() const;
        size_t TotalLength(int startLine, int lineCount) const;

        size_t Split(const TSTR& strSplit, TCHAR splitChar);
        size_t Split(const TCHAR* strSplit, TCHAR splitChar);

        TSTR Join(TCHAR joinChar);
	    TSTR Join(const TCHAR* joinText);
        TSTR Join(const TSTR& joinText);

        TSTR Join(TCHAR joinChar, int startLine, int lineCount);
        TSTR Join(const TCHAR* joinText, int startLine, int lineCount);
        TSTR Join(const TSTR& joinText, int startLine, int lineCount);

        void Remove(int line);
        void RemoveTrailingEmptyLines();
    		
    private:
	    static size_t CountInstancesOf(const TCHAR* str, TCHAR c);
	};
}


#endif
