#ifndef OgreMax_TextInMarkerParser_INCLUDED
#define OgreMax_TextInMarkerParser_INCLUDED


//Classes----------------------------------------------------------------------
namespace OgreMax
{    
    /**
     * Parses the text between two text markers
     * For example, it can be used to parse the text between the --OgreMax-- marker in the following:
     *      --OgreMax--
     *          text inside the marker
     *      --OgreMax--
     */
    class TextInMarkerParser
    {
    public:
        TextInMarkerParser();

        bool Parse(const TSTR& text, const TSTR& marker);
        bool Parse(const TSTR& text, const TSTR& markerStart, const TSTR& markerEnd);

        const TSTR& GetMarkedText() const;

        void ReplaceMarkedText(TSTR& result, const TSTR& replaceWith, bool includeMarkers) const;        

    protected:
        TSTR text;        
        TSTR markedText;

        int offsetToMarkerStart;
        int offsetToMarkerStartEnd;
        
        int offsetToMarkerEnd;
        int offsetToMarkerEndEnd;
    };
}


#endif