#ifndef OgreMax_TypeDetectors_INCLUDED
#define OgreMax_TypeDetectors_INCLUDED


//Classes----------------------------------------------------------------------
namespace OgreMax
{    
    class ObjectTypeDetector
    {
    public:
        ObjectTypeDetector();
        ObjectTypeDetector(INode* node, TSTR* typeTextPtr = NULL, bool useTypeText = true);

        void Detect(INode* node, TSTR* typeTextPtr = NULL, bool useTypeText = true);

        enum Type
        {
            DEFAULT,
            IGNORE_OBJECT, //Can't use IGNORE because it's a Windows macro
            EMPTY,
            MODEL_INSTANCE,
            ENTITY,
            LIGHT,
            CAMERA,
            EXTERNAL,
            TERRAIN,
            SKY_BOX,
            SKY_DOME,
            SKY_PLANE,
            PARTICLE_SYSTEM,
            BILLBOARD_SET,
            BILLBOARD,
            PLANE
        };

        bool IsAllowed(Type type) const;

        /** The selected type */
        Type type;

        /** All the types that are allowed, including the selected type */
        std::vector<Type> allowedTypes;

        /** The textual type, if any was specified*/
        TSTR typeText;
    };

    class MeshAnimationTypeDetector
    {
    public:
        MeshAnimationTypeDetector();
        MeshAnimationTypeDetector(INode* node, TSTR* typeTextPtr = NULL, bool useTypeText = true);

        void Detect(INode* node, TSTR* typeTextPtr = NULL, bool useTypeText = true);

        enum Type
        {
            DEFAULT,
            POSE_ONLY,
            MORPH_ONLY,
            SKELETON_ONLY,
            SKELETON_AND_POSE,
            SKELETON_AND_MORPH
        };
        /** The selected type */
        Type type;

        /** All the types that are allowed, including the selected type */
        std::vector<Type> allowedTypes;

        bool hasSkeleton;
        bool hasMorpher;
    };
}


#endif