
//Includes---------------------------------------------------------------------
#include "stdafx.h"
#include "UserDataTabPage.h"
#include "CommonSettings.h"
#include "PluginGlobals.h"
#include "resource.h"

using namespace OgreMax;


//Implementation----------------------------------------------------------------

//UserDataTabPage-------------------------
UserDataTabPage::UserDataTabPage(UserDataSettings& userDataSettings) : settings(userDataSettings)
{
}

void UserDataTabPage::Attach(HWND hDlg)
{
    DialogBase::Attach(hDlg);

    SetGUIData();
}

void UserDataTabPage::GetGUIData()
{
    this->settings.userDataMarker = PluginGlobals::OgreMaxUserDataPropertyMarker;

    //"Is XML CDATA" checkbox
    this->settings.isUserDataCDATA = IsDlgButtonCheckedText(IDC_IS_USER_DATA_CDATA);

    //ID edit
    GetDlgItemText(IDC_ID_EDIT, this->settings.id);

    //Reference edit
    GetDlgItemText(IDC_REFERENCE_EDIT, this->settings.userDataReference);

    //User data edit
    GetDlgItemText(IDC_USER_DATA_EDIT, this->settings.userData);
}

void UserDataTabPage::SetGUIData()
{
    //"Is XML CDATA" checkbox
    CheckDlgButton(IDC_IS_USER_DATA_CDATA, CommonSettings::Values::IsUserDataCDATA(this->settings.isUserDataCDATA));

    //ID edit
    SetDlgItemText(IDC_ID_EDIT, this->settings.id);

    //Reference edit
    SetDlgItemText(IDC_REFERENCE_EDIT, this->settings.userDataReference);

    //User data edit
    SetDlgItemText(IDC_USER_DATA_EDIT, this->settings.userData);
}

INT_PTR UserDataTabPage::DialogProc(UINT message, WPARAM wParam, LPARAM lParam, bool& handled)
{
    switch (message)
    {            
        case WM_CLOSE:
        {
            handled = true;
            break;
        }
    }

    return 0;
}
