// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows XP or later.
#define WINVER 0x0501		// Change this to the appropriate value to target other versions of Windows.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 6.0 or later.
#define _WIN32_IE 0x0600	// Change this to the appropriate value to target other versions of IE.
#endif

//Windows Header Files:
#include <windows.h>
#include <windowsx.h>

//C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

//Additional headers required by the plugin

//Ogre includes go first since Max defines some macros that cause problems
#include <OgrePrerequisites.h>
#include <Ogre.h>
#include <OgreColourValue.h>
#include <OgreVector3.h>
#include <OgreMesh.h>
#include <OgreNoMemoryMacros.h>
#include <OgreSerializer.h>
#include <OgreMemoryMacros.h>
#include <OgreMeshSerializer.h>
#include <OgreSkeletonSerializer.h>
#include <OgreDefaultHardwareBufferManager.h>

//Max includes
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#include <Max.h>
#include <IGame/IGame.h>
#include <IGame/IGameModifier.h> 
#include <plugapi.h>
#include <stdmat.h>
#include <shaders.h>
#include <impexp.h>
#include <CS/BipedApi.h>
#include <CS/KeyTrack.h>
#include <CS/phyexp.h>
#include <iparamb2.h>
#include <iskin.h>
#include <tab.h>
#include <notetrck.h>
#include <istdplug.h>
#include <iparamm2.h>
#include <guplib.h>
#include <imenuman.h>
#include <MAXScrpt\MAXScrpt.h>
#include <MAXScrpt\Listener.h>
#include <Notify.h>
#include <iFnPub.h>
#include <ActionTable.h>
#include <iMenuMan.h>
#include <ParticleFlow/PFClassIDs.h>
#include <gport.h>
#include <hsv.h>
#include <iColorMan.h>
#include <bmmlib.h>
#undef min

//Other includes
#include <map>
#include <vector>
#include <fstream>
#include <string>
#include <tchar.h>
#include <queue>
#include <map>
#include <sstream>
#include <list>
#include <iosfwd>
#include <iostream>
#include <sys/stat.h>
#include <stdlib.h>

#include "tinyxml/tinyxml.h"

#ifdef UNICODE
    typedef std::wstring stdstring;    
    typedef std::wostream stdostream;
    typedef std::wofstream stdofstream;
    typedef std::wostringstream stdstringstream;
    typedef std::wifstream stdifstream;
#else
    typedef std::string stdstring;
    typedef std::ostream stdostream;
    typedef std::ofstream stdofstream;
    typedef std::ostringstream stdstringstream;
    typedef std::ifstream stdifstream;
#endif

#define ScriptPrint (the_listener->edit_stream->printf)

#if MAX_VERSION_MAJOR < 9
    inline RemapDir& DefaultRemapDir()
    {
        return NoRemap();
    }
#endif